#!/usr/bin/env python
# -*- coding:utf-8 -*-
'''Associe des commandes aux touches multimedia'''
#
#       python-dbus_mmctrl.py
#       
#       Copyright 2009 Willy Petit
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.

import os, sys, dbus, gobject, pwd, optparse
from dbus.mainloop.glib import DBusGMainLoop
from subprocess import PIPE,Popen,call

#~ msg_usage = "utilisation: %prog [options]\n\
#~ \nVoir /usr/share/doc/python-dbus_mmctrl/LISEZMOI \
#pour plus d'information."    
#~ msg_helprun="Lancer la capture des signaux"
#~ msg_helpsign="Voir les signaux"
#~ msg_noconfigfile='mmctrl.conf vide ou inexistant.'
#~ msg_wait="Attendez 5 secondes ou appuyez sur touche multimédia pour quitter"

msg_usage = "usage: %prog [options]\n\nSee /usr/share/doc/\
python-dbus_mmctrl/README for more information."
msg_helprun = "Start capture"
msg_helpsign = "Show signals"
msg_noconfigfile = 'mmctrl.conf is empty or does not exist.'
msg_wait = "Wait 5 seconds or press a multimedia key for exit"

parser = optparse.OptionParser(msg_usage)
parser.add_option("-r", "--run", action="store_true", dest="run", \
 help=msg_helprun)
parser.add_option("--signals", action="store_true", dest="sign", \
 help=msg_helpsign)
(options, args) = parser.parse_args()


DBusGMainLoop(set_as_default=True)
sys_bus = dbus.SystemBus()

def read_confs():
    ''' Lecture du fichier de configuration de l'utilisateur '''
    try:
        HOME = pwd.getpwnam(user).pw_dir
        if os.path.isfile(HOME+'/.mmctrl.conf'):
            conf_file = open(HOME+'/.mmctrl.conf').readlines()
        elif os.path.isfile('/usr/share/python-dbus_mmctrl/mmctrl.conf'):
            conf_file = open(\
            '/usr/share/python-dbus_mmctrl/mmctrl.conf').readlines()

        confs = {}
        for line in conf_file:
            if not line.startswith('#') and not line == '\n':
                try:
                    confs[line.split('=')[0].strip()] = line.split('=')[1]\
                    .split('\n')[0].strip()
                except:
                    pass
    except:
        confs = {}
    return confs            
def showsignal(sender = None, destination = None):
    ''' retourne le signal de la touche multimedia appuyée '''
    if sender == 'ButtonPressed':
        print 'received signal:', destination
        loop.quit()
    

def run(sender = None, destination = None):
    '''Execute ( avec les droits de l'utilisateur qui utilise tty7 ) la \
    commande associée au bouton pressé'''
    if sender == 'ButtonPressed':
        global user, user_old, loaded_confs
        user = Popen("who -u|grep tty7|cut -d' ' -f1",shell=True,\
        stdout=PIPE).communicate()[0].replace('\n','')
        if user_old != user:
            loaded_confs = read_confs()
            user_old = user
             
        if user != 'root' and user != '' :
            for sign in loaded_confs.keys():
                if destination.startswith(sign):
                    os.putenv('DISPLAY',':0.0')
                    call(\
                    'su - %s -c "export DISPLAY=:0.0 ;\
                     %s > /dev/null 2>&1 &"' \
                     %(user, loaded_confs[sign]), shell=True)
        
        
            

def enum_inputs(bus):
    '''liste les touches multimédia présentes sur le système'''
    obj = bus.get_object('org.freedesktop.Hal', '/org/freedesktop/Hal/Manager')
    hal_manager = dbus.Interface(obj, 'org.freedesktop.Hal.Manager')
    return hal_manager.FindDeviceByCapability("input.keys")


def hook_buttons(bus, callback):
    '''Connecte les touches multimédia'''
    for udi in enum_inputs(bus):
        obj = bus.get_object('org.freedesktop.Hal', udi)
        iface = dbus.Interface(obj, 'org.freedesktop.Hal.Device')
        iface.connect_to_signal("Condition", callback)

loop = gobject.MainLoop()
if options.run:
    user = 'root'
    user_old = 'root'
    loaded_confs = read_confs()    
    hook_buttons(sys_bus, run)
    loop.run()

elif options.sign:
    print msg_wait
    gobject.timeout_add (5000, sys.exit, 0)
    hook_buttons(sys_bus, showsignal)
    loop.run()
else:
    print msg_usage
    sys.exit(1)




